;
; ╔═════════════════════════════════════════════════════════════════════════╗
; ║     This file is generated by The Interactive Disassembler (IDA)        ║
; ║     Copyright (c) 2006 by DataRescue sa/nv, <ida@datarescue.com>        ║
; ║ Licensed to: Toorukh Makto                                              ║
; ╚═════════════════════════════════════════════════════════════════════════╝
;
; Input MD5   : 62D1D27B91ACDA222ADBF5E7CB280821

; File Name   : DISKWR.PAR
; Format      : Binary file
; Base Address: 0000h Range: 0200h - 02B0h Loaded length: 00B0h

; Processor:        K1801VM1
; Target assembler: BKTurbo8 Cross Assembler

; ═══════════════════════════════════════════════════════════════════════════
.include "parvars.asm"

BLCmd:          .ascii "BL"
                .word @DKCmd

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

BLFunc$:        decb    R1              ; сколько параметров?
                beq     2$              ; всего один
                bpl     1$              ; больше одного

ErrorArg$:      emt     177             ; Вывод сообщения об ошибке и код ошибки - параметр за командой.
                                        ; Затем сразу переход к ожиданию команд.
                .ascii "ОП"
; ───────────────────────────────────────────────────────────────────────────

1$:             tst     R2              ; проверим длину
                bmi     ErrorArg$       ; <0 - ошибка
                mov     R2, (PC)+       ; сохраним размер блока
BlkSize:        .word 400

2$:             mov     R4, (PC)+       ; сохраним адрес блока
BlkAddr:        .word 40000

                return
; End of function BLFunc$

; ───────────────────────────────────────────────────────────────────────────

DKCmd:          .ascii "DK"
                .word @SDCmd

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


DKFunc$:        call    CheckArgs       ; Выход: R0 - номер блока
                                        ;        R1 - размер блока
                                        ;        R2 - адрес блока
                                        ;        R3 - адрес блока параметров
                call    @#160010
                movb    R0, 34(R3)
                br      0Stop$
; End of function DKFunc$

; ───────────────────────────────────────────────────────────────────────────
SDCmd:          .ascii "SD"
                .word @LDCmd

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


SDFunc$:        call    CheckArgs       ; Выход: R0 - номер блока
                                        ;        R1 - размер блока
                                        ;        R2 - адрес блока
                                        ;        R3 - адрес блока параметров
                neg     R1              ; для записи
                br      IOProc$
; End of function SDFunc$

; ───────────────────────────────────────────────────────────────────────────
LDCmd:          .ascii "LD"
                .word ChainEnd

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


LDFunc$:        call    CheckArgs       ; Выход: R0 - номер блока
                                        ;        R1 - размер блока
                                        ;        R2 - адрес блока
                                        ;        R3 - адрес блока параметров

IOProc$:        call    @#160004
                bcc     0Stop$
                clr     @#177130
                movb    @#52, R0        ; выведем номер ошибки
                emt     121             ; Сделать перевод строки, с дублированием на принтер
                emt     132             ; Вывод байта из R0 в восьмеричной системе счисления
                emt     177             ; Вывод сообщения об ошибке и код ошибки - параметр за командой.
                                        ; Затем сразу переход к ожиданию команд.
                .ascii "DK"
; ───────────────────────────────────────────────────────────────────────────

0Stop$:         clr     @#177130        ; ошибок нет - порядок
                return
; End of function LDFunc$


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Выход: R0 - номер блока
;        R1 - размер блока
;        R2 - адрес блока
;        R3 - адрес блока параметров

CheckArgs:      decb    R1              ; сколько параметров?
                bmi     ErrorArg$       ; нисколько - ошибка
                beq     1$              ; один - задан только номер блока
                                        ; два - задан ещё и адрес
                mov     R2, BlkAddr     ; сохраним адрес

1$:             mov     R4, R0
                .addr   R3, BPar
                mov     BlkAddr, R2
                mov     BlkSize, R1
                return
; End of function CheckArgs

; ───────────────────────────────────────────────────────────────────────────
BPar:           .word 0
                .word 0
                .word 177777
                .word 177777
                .word 20000
                .word 20000
                .word 17074
                .word 40000
                .word 0
                .word 0
                .word 0
                .word 0
                .word 0
                .word 0
                .word 0
                .word 0
                .word 0
                .word 0
                .word 0
                .word 0
                .word 0
                .word 0
                .word 0
                .word 0
                .word 12
                .word 0
                .word 0

                .END
